// 002 u_composite
// 18 sep 2010

// -- (C) John COLIBRI 2010
// -- documentation: http://www.jcolibri.com

(*$r+*)
unit u_composite;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, u_i_shape_list;

type
  TForm1 = class(TForm, i_shape)
    Panel1: TPanel;
    PageControl1: TPageControl;
    display_: TTabSheet;
    memo_: TTabSheet;
    Panel2: TPanel;
    Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    memo_panel_: TPanel;
    Splitter1: TSplitter;
    compute_surface_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure close_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure compute_surface_Click(Sender: TObject);
  private
  public
    function f_surface: Integer;
  end;

    var Form1: TForm1;

  implementation
    uses u_c_log, u_c_display
        , u_c_shape_list
       ;

    {$R *.DFM}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.close_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    function TForm1.f_surface: Integer;
      begin
        Result:= Width* Height;
      end;

    procedure TForm1.compute_surface_Click(Sender: TObject);
      var l_c_rectangle: c_rectangle;
          l_i_shape: i_shape;
      begin
        with c_shape_list.create_shape_list do
        begin
          l_c_rectangle:= c_rectangle.create_rectangle(10, 20);
          l_i_shape:= l_c_rectangle;

          add_shape(l_c_rectangle);
          add_shape(Form1);

          // -- check individual
          display('rectangle_surface '+ IntToStr(l_c_rectangle.f_surface));
          display('Form1_surface     '+ IntToStr(Form1.f_surface));
          display('total_surface     '+ IntToStr(f_surface));

          Free;
        end; // with c_shape_list
      end; // compute_surface_Click

end.


